/*------------------------------------------------------------------------------

Copyright 2005 CAMBADA Team, All Rights Reserved
DET/IEETA, University of Aveiro, http://www.ieeta.pt/atri/cambada

Sempahore utility functions

Modified:
2005-04-08 : Created by Paulo Pedreiras (pedreiras@det.ua.pt)

------------------------------------------------------------------------------*/
#include <sys/types.h>
#include <sys/sem.h>

#include <sem_utils.h>

/*
 * Semaphore wait/signal primitives 
 */
int sem_wait(int sem_id)
{
  struct sembuf sem_b;
  
  sem_b.sem_num=0;
  sem_b.sem_op=-1;
  sem_b.sem_flg=SEM_UNDO;
  return semop(sem_id,&sem_b,1);
}

int sem_signal(int sem_id)
{
  struct sembuf sem_b;
  
  sem_b.sem_num=0;
  sem_b.sem_op=1;
  sem_b.sem_flg=SEM_UNDO;
  return semop(sem_id,&sem_b,1);
}
