/***************************************************************************
 *   Copyright (C) 2007 by Mauro Rodrigues				   *
 *   mauro.r@ua.pt							   *
 *                                                                         *
 *   PhUA - Projecto Humanóide da Universidade de Aveiro 07/08		   *
 *	@Sistemas de Tempo-Real 07/08					   *
 ***************************************************************************/

#ifndef _SerialPort_h_
#define _SerialPort_h_

#define COM_DEVICE "/dev/ttyS1"		/*Porta serie*/
//#define COM_DEVICE "/dev/ttyUSB0"		/*Porta USB*/


//#include <unistd.h>
//#include <sys/types.h>
//#include <sys/stat.h>
//#include <string.h>
//#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <iostream>
#include <string>
#include <vector>
#include <termios.h>
#include "data.h"

using namespace std;





class SerialPort
{

public:

	SerialPort()
	{
	};
	
	virtual ~SerialPort()
	{
	};

	/*
	* Inicializacao da porta sarie
	*/
	int initcom(void);

	/*
	 * Fecho da porta serie 
	 */
	int killcom(void);

	/*
	 * Escrever na porta serie 
	 */
	int writecom(unsigned char msg);

	/*
	 * Ler da porta serie
	 */
	int readcom(unsigned char *msg);

	/*
	 * Limpar os buffers da porta
	*/
	int resetcom(void);

private:

	//int h;

};




#endif // #ifndef _SerialPort_h_
