/***************************************************************************
 *   Copyright (C) 2007 by Mauro Rodrigues				   *
 *   mauro.r@ua.pt							   *
 *                                                                         *
 *   PhUA - Projecto Humanóide da Universidade de Aveiro 07/08		   *
 *	@Sistemas de Tempo-Real 07/08					   *
 ***************************************************************************/
#ifndef CVISION_H
#define CVISION_H

#include <string>

#include <highgui.h>
#include <cv.h>
#include <cxcore.h>
#include <cvaux.h>

#include "visiondefs.h"

/**
	@author Mauro,,, <mauro.r@ua.pt>
*/
class CVision{
public:
	CvCapture* m_pCap;
	IplImage* m_pImg;

public:
	CVision();
	CVision(unsigned width, unsigned height, int device, int depth, int channels);
	CVision(CVision& vis);/*A REVER!!!!!*/
	~CVision();

	void Display(void);
	void Display(char *window_name);
	void Refresh(void);
	void CapnSave(char *dest);
	int DetectColor(HSVColour color, CVision* visarr[], char* index[]);
	void DetectShape(char *shape);
	void AddText(char *text); //Default is upper left corner!
	void AddText(char *text, int posx, int posy);

// 	CVision& operator=(const CVision& vis);/*A REVER!!!!!*/
};

#endif
