/***************************************************************************
 *   Copyright (C) 2007 by Mauro Rodrigues				   *
 *   mauro.r@ua.pt							   *
 *                                                                         *
 *   PhUA - Projecto Humanóide da Universidade de Aveiro 07/08		   *
 *	@Sistemas de Tempo-Real 07/08					   *
 ***************************************************************************/

/* PMAN Definitions */

#define SHMEM_PMAN_KEY 0x7010	/* Shared memory key, PMAN primitives */
#define SEM_PMAN_KEY 0x7020	/* Semaphore key for PMAN primitives */

#define SHMEM_ATOP_KEY 0x7011 /* Shared memory key, IPC Acq to Proc */
#define SHMEM_PTOT_KEY 0x7012 /* Shared memory key, IPC Proc to Track */
#define SHMEM_RTDB_KEY 0x7013 /* Shared memory key, IPC Track to Ctrl */

#define SEM_ATOP_KEY   0x7021 /* Semaphore key for IPC Acq to Proc */
#define SEM_PTOT_KEY   0x7022 /* Semaphore key for IPC Proc to Track */
#define SEM_RTDB_KEY   0x7023 /* Semaphore key for IPC Track to Ctrl */
