/*------------------------------------------------------------------------------

Copyright 2005 CAMBADA Team, All Rights Reserved
DET/IEETA, University of Aveiro, http://www.ieeta.pt/atri/cambada

Semaphore utility functions header

Modified:
2005-04-08 : Created by Paulo Pedreiras (pedreiras@det.ua.pt)

------------------------------------------------------------------------------*/

#ifndef UTILS_H_INCLUDED
#define UTILS_H_INCLUDED

/* 
 * arg for semctl system calls. 
 *
 */
union dsemun{
	int val;			/* value for SETVAL */
	struct semid_ds *buf;		/* buffer for IPC_STAT & IPC_SET */
	unsigned short *array;		/* array for GETALL & SETALL */
	struct seminfo *__buf;		/* buffer for IPC_INFO */
	void *__pad;
};


/*
 * Function prototypes
 *
 */
#ifdef __cplusplus
extern "C" {
#endif
  
  int sem_wait(int sem_id);
  int sem_signal(int sem_id);

#ifdef __cplusplus
}
#endif

#endif
